//+------------------------------------------------------------------+
//|                                                 UnequalHedge.mq4 |
//+------------------------------------------------------------------+
#property copyright "Copyright  2007,Bolla"
#property link      "http://www.forex-tsd.com"

#include <stdlib.mqh>

//inputs esterni
extern double TakeProfitLong     = 27;
extern double TakeProfitShort    = 27;
extern bool   AutoPipStep        = true;
extern int    ATR_MTF            = 1440;
extern int    ATR_Period         = 21;
extern int    Long_distance      = 20;
extern int    Short_distance     = 20;
extern double Multiplier         = 2;
extern int    MaxTrades          = 10;
extern bool   mm                 = true;
extern int    AccountType        = 2;
extern double risk               = 1;
extern int    Slippage           = 3;

//variabili globali
string  Name_Expert    = "UnequalHedge";
double  stopLossB      = 1000; 
double  stopLossS      = 1000; 
double  InitLots       = 0.01;
double  MaxLot         = 1;
int     SL             = 20;
double  sB=0,sS=0;
int c,j,cnt;
double LotsB,LotsS,Long,Short;
double LastB=0,LastS=1000,SecureProfit; 


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init()
  {
  return(0);
  }

//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit()
  {
  return(0);
  }

//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start()
   {
   if(Bars<1)   {Print("bars less than 1");return(0);}
   
   double   Price=iClose(NULL,0,0);
   int DLong=Long_distance;
   int DShort=Short_distance;
   if(AutoPipStep)
   {
   DLong=DynamicPipStep();
   DShort=DynamicPipStep();
   TakeProfitLong=DynamicPipStep();
   TakeProfitShort=DynamicPipStep();
   }
      
   if (!ExistPositions()) {sB=0; sS=0;}
   int T=0;
   int B=0;  
   for(int i=0;i<OrdersTotal();i++) 
      { 
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert)   
        { 
        int type=OrderType();
        switch(type)
           {
           case OP_BUY:
              sB=1;
              T++;
              LastB=OrderOpenPrice();
              break;
           case OP_SELL:
              sS=2;
              B++;
              LastS=OrderOpenPrice();
              break;
           }
        }    
      }

   if(mm)
   {
      if (AccountType==0)
      {LotsB=NormalizeDouble(MathCeil((risk*AccountBalance())/10000)/10,1);
       LotsS=NormalizeDouble(MathCeil((risk*AccountBalance())/10000)/10,1);}
      if (AccountType==1)
      {LotsB=NormalizeDouble((risk*AccountBalance())/100000,2);
       LotsS=NormalizeDouble((risk*AccountBalance())/100000,2);}
      if (AccountType==2)
      {LotsB=NormalizeDouble((risk*AccountBalance())/10000,2);
       LotsS=NormalizeDouble((risk*AccountBalance())/10000,2); }
   }
   else 
   {
   InitLots=MathCeil(AccountBalance()/6000)/100;
   LotsB=InitLots;
   LotsS=InitLots;
   LotsB=MathFloor(LotsB*100)/100;
   LotsS=MathFloor(LotsS*100)/100;
   }
   if (LotsB < NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2)) LotsB = NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2);
   if (LotsS < NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2)) LotsS = NormalizeDouble((MarketInfo(Symbol(), MODE_MINLOT)),2);
   if (LotsB > 3) LotsB=3;
   if (LotsS > 3) LotsS=3;

/*   InitLots=MathCeil(AccountBalance()/6000)/100;
   LotsB=InitLots;
   LotsS=InitLots;
   LotsB=MathFloor(LotsB*100)/100;
   LotsS=MathFloor(LotsS*100)/100;
   if (LotsB<0.01) LotsB=0.01;
   if (LotsS<0.01) LotsS=0.01;*/
   SecureProfit=LotsB+LotsS*MaxTrades*5;

   stopLossB=SL+(MaxTrades-1)*DLong;
   stopLossS=SL+(MaxTrades-1)*DShort;

   for (j=0;j<T;j++) {LotsB=Multiplier*LotsB; stopLossB=stopLossB-DLong;}
   for (j=0;j<B;j++) {LotsS=Multiplier*LotsS; stopLossS=stopLossS-DShort;}

   if (AccountBalance()>6000) MaxLot=MathFloor(AccountBalance()/40)/100;
   if (LotsB>MaxLot) LotsB=MaxLot; 
   if (LotsS>MaxLot) LotsS=MaxLot; 
   if (LotsB>100) LotsB=100; 
   if (LotsS>100) LotsS=100; 


   if (T==0) { Long=1000;}
   if (B==0) {Short=-1000;}
   if ((T>0)||(B>0))
      {
      if ((sB==1)&&(Long>LastB)) Long=LastB;
      if ((sS==2)&&(Short<LastS)) Short=LastS;
      }

   if ((T==MaxTrades)||(B==MaxTrades)) c=1;
   if ((T==0)||(B==0)) c=0;

   if ((sB==0)||(sS==0)) if(AccountFreeMargin()<(1000*LotsB))
      {
      Print("We have no money. Free Margin = ", AccountFreeMargin());
      return(0);
      }

   double spread=(Ask-Bid)/Point;

   if ((sB==0)&&(c==0))  {OpenBuy();sB=1;} 
   if ((sS==0)&&(c==0))  {OpenSell();sS=2;}   

   if ((T<MaxTrades)&&(B<MaxTrades))
      {
      if ((sB==1)&&(Price<=(LastB-(DLong+spread)*Point))&&(c==0))   {OpenBuy();sB=1;return(0);}
      if ((sS==2)&&(Price>=(LastS+(DShort)*Point))&&(c==0))         {OpenSell();sS=2;return(0);}
      if ((sB==1)&&(Price>=(Long+TakeProfitLong*Point)))            {closeAllOrders(0);sB=0;return(0);}
      if ((sS==2)&&(Price<=(Short-(TakeProfitShort+spread)*Point))) {closeAllOrders(1);sS=0;return(0);} 
      }

	  double Profit=0;
     for(cnt=0;cnt<OrdersTotal();cnt++)
     {
      if (OrderSelect(cnt, SELECT_BY_POS, MODE_TRADES))
      {
       if ((OrderSymbol()==Symbol() && OrderMagicNumber()==0))
        Profit=Profit+OrderProfit();         
      }
     }
	     //Print(Symbol,":",Profit);
	     if (Profit>=SecureProfit) 
	     {
	        closeAllOrders(0);
	        closeAllOrders(1);
	        return(0);
	     }
  return (0);
}//end start


// - - - - - - FUNZIONI - - - - - - -
 

bool ExistPositions()
   {
   for(int i=0;i<OrdersTotal(); i++)
      {
      OrderSelect(i,SELECT_BY_POS,MODE_TRADES);
      if(OrderSymbol()==Symbol() && OrderComment()==Name_Expert) return(True);
         else return(false);
      }   
}

void OpenBuy()
   { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLotB(); 
   ldStop = Ask-Point*stopLossB; 
   ldTake = NormalizeDouble(GetTakeProfitBuy(),Digits); 
   lsComm = GetCommentForOrder(); 
   OrderSend(Symbol(),OP_BUY,ldLot,NormalizeDouble(Ask,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Blue);
}
 
void OpenSell()
   { 
   double ldLot, ldStop, ldTake; 
   string lsComm; 
   ldLot = GetSizeLotS(); 
   ldStop = Bid+Point*stopLossS; 
   ldTake = NormalizeDouble(GetTakeProfitSell(),Digits); 
   lsComm = GetCommentForOrder();
   OrderSend(Symbol(),OP_SELL,ldLot,NormalizeDouble(Bid,Digits),Slippage,ldStop,ldTake,lsComm,0,0,Red); 
}

void closeAllOrders(int type)
   {
   for(int c=0;c<OrdersTotal();c++)
      {
      OrderSelect(c,SELECT_BY_POS,MODE_TRADES); 
      if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_BUY && type==0)
         {
         OrderClose(OrderTicket(), OrderLots(),Bid,Slippage, White);
         }
      if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType()==OP_SELL && type==1)
         {
         OrderClose(OrderTicket(), OrderLots(), Ask,Slippage, White);
         }   
      if (OrderSymbol()==Symbol() && OrderComment()==Name_Expert && OrderType() > 1)  {OrderDelete(OrderTicket());
      }
   }
} 

int DynamicPipStep()
{
   int PipStep=iATR(NULL,ATR_MTF,ATR_Period,0)/Point;
   return(PipStep);
}

string GetCommentForOrder() {return(Name_Expert);} 
double GetSizeLotB() {return(LotsB);} 
double GetSizeLotS() {return(LotsS);} 
double GetTakeProfitBuy() {return(Ask+TakeProfitLong*Point);} 
double GetTakeProfitSell() {return(Bid-TakeProfitShort*Point);} 